module top(a,b,result,clk,rstn,delay,complete);

parameter W = 17;
parameter N = 1024;

input clk,rstn;
output signed [2*W-1:0] result;
output signed [W-1:0] a,b;
output [5:0] delay;
output complete;
wire [5:0] delay;
wire complete;
wire signed [W-1:0] a,b;
reg signed [W-1:0] series_x,series_y;
wire signed [2*W-1:0] result;
wire clk,rstn;
reg [clogb2(N)-1:0] ad=0;

function integer clogb2(input integer N);
        begin
                for(clogb2=0;N>1;clogb2=clogb2+1)
                        N = N >> 1;
        end
endfunction
XCORR_Top
uut
(
    .series_x(series_x),
    .series_y(series_y),
    .result(result),
    .clk(clk),
    .rstn(rstn),
    .delay(delay),
    .complete(complete)
);

reg signed [W-1:0] memx [0:N-1];
initial begin
        $readmemb("data/o_x.dat",memx);
end
reg signed [W-1:0] memy [0:N-1];
initial begin
        $readmemb("data/o_y.dat",memy);
end
always @(posedge clk) begin
        if(!rstn) begin
                series_x<=0;
                series_y<=0;
        end
        else begin
                series_x<=memx [ad];
                series_y<=memy [ad];
        end
end
always @(posedge clk) begin
        if(!rstn) begin
                ad<=0;
        end
        else begin
                ad<=ad+1'b1;
        end
end

assign a=series_x;
assign b=series_y;
endmodule

